;===============================================================================
; 80x30-9.ASM version 1.1 (C) Copyright 1992 Ignacio Garca Prez    (17/12/92)
;
; Debe ser convertido a .COM antes de su ejecucin.
;
;       El autor se reserva todos los derechos sobre este cdigo fuente.
; Puede ser incluido en parte o en su totalidad en otros programas siempre
; y cuando se cumplan los siguientes requisitos:
;
;       1- Que tanto el programa como su cdigo fuente sean de dominio pblico,
;       es decir, que no se cobre nada por ellos, ni en el momento de su
;       distribucin ni posteriormente.
;
;       2- Que esta cabecera en su totalidad sea incluida en la documentacin
;       del programa.
;
;       3- Que el Copyright del autor, (ver init_msg) se incluya en el CODIGO
;       del programa.

.model tiny

print   macro msg
        mov ah,09h
        mov dx,offset &msg
        int 21h
        endm

.code
org 100h
inicio: jmp main

;===============================================================================
; Datos

init_msg        db '80x30-9 v1.1 (C) Copyright 1992 Ignacio Garca Prez.'
                db '    (17/12/92)',13,10,36
init_len        EQU $-init_msg

oldint10h       dd ?            ; Antiguo vector de INT 10h

flag_80x30      db 0            ; Flag que indica modo 80x30 activo
flag_install    db 0            ; Flag que indica si ya est residente

CRTC_reg        dw 00c11h       ; Vertical Display End (desproteger regs. 0-7)
                dw 00d06h       ; Vertical Total
                dw 03e07h       ; Overflow
                dw 0ea10h       ; Vertical Retrace Start
                dw 08c11h       ; Vertical Retrace End (y proteger regs. 0-7)
                dw 0df12h       ; Vertical Display Enable End
                dw 0e715h       ; Start Vertical Blanking
                dw 00616h       ; End Vertical Blanking

;===============================================================================
; Nueva rutina de servicio de la INT 10h. La atrapa, y cada vez que solicitamos
; un cambio de modo 2 o 3, nos pone en modo 80x30 slo si el flag interno as
; lo indica, si no, cambia al modo 80x25 normal.
; Esta rutina ha sido concebida poniendo especial cuidado en que tarde lo menos
; posible en el caso de que no se pida un cambio de modo.

int10h proc far

        or ah,ah                ; Si no se pide un cambio de modo, continuamos
        jz set_mode             ; con la antigua rutina de servicio de int 10h
old_int:
        jmp cs:oldint10h

set_mode:
        push ax                 ; Tomamos slo nmero de modo, ya que el bit
        and al,7fh              ; 7 indica si hay que borrar o no la pantalla
        cmp al,2                ; Si es modo 2, actuamos
        jz popup
        cmp al,3                ; Si es modo 3, actuamos tambin
        jz popup
        pop ax
        jmp cs:oldint10h        ; Si no, continuamos con la antigua rutina

popup:
        pop ax                  
        pushf                   ; Dejamos a la BIOS cambiar el modo
        call cs:oldint10h
        cmp cs:flag_80x30,0     ; Comprobamos flag, y si no es 0, ponemos 80x30
        jz not_80x30
        call set_80x30
not_80x30:
        iret

int10h endp

;===============================================================================
; Rutina que, a partir del modo 2 o 3, cambia a 30 lneas.

set_80x30 proc

        push ax                         ; Salvamos TODOS los registros usados
        push bx
        push cx
        push dx
        push si
        push ds
        push es

        mov ax,cs                       ; Ponemos el segmento de datos propio
        mov ds,ax

        mov ax,0040h                    ; Modificamos algunos parmetros de
        mov es,ax                       ; la zona de datos de la BIOS:
        mov word ptr es:[004ch],8192    ; Tamao de pgina en bytes y
        mov byte ptr es:[0084h],29      ; Nmero de lneas-1

        mov dx,es:[0063h]               ; Tomamos direccin base del CRTC
        mov si,offset CRTC_reg          ; Tabla de nuevos registros
        mov cx,8                        ; Vamos a modificar 8

        cli                             ; Inhibimos las interrupciones

CRTC:   lodsw                           ; Bucle que lee dato y lo
        out dx,ax                       ; envia al puerto del CRTC
        loop CRTC

        mov dx,3cch                     ; Miscellaneous Output
        in al,dx
        and al,00110011b                ; Cambiamos slo el clock mode a 1
        or al,11000100b                 ; y la VSP a negativa.
        mov dx,3c2h
        out dx,al

        sti                             ; Habilitamos de nuevo las interrup.

        mov ax,1200h                    ; Activamos la emulacin de cursor
        mov bl,34h
        pushf
        call oldint10h

        mov ah,12h                      ; Selecciona rutina alternativa
        mov bl,20h                      ; de impresin
        pushf
        call oldint10h

        pop es
        pop ds
        pop si
        pop dx
        pop cx
        pop bx
        pop ax

        ret                             ; Termina

set_80x30 endp

;===============================================================================
; Aqu finaliza la parte residente

last_byte       EQU $

;===============================================================================
; Datos que no es necesario que quieden residentes

installed_msg   db 'Programa ya instalado en memoria.',13,10,36
help_msg        db 'Uso: 80x30-9 +|-',13,10
                db '     + Modo especial 80x30 (VGA necesaria)',13,10
                db '     - Modo estandar 80x25',13,10,36
not_vga_msg     db 'Error: tarjeta VGA no detectada.',7,13,10,36

;===============================================================================

set_text_mode proc

        mov ah,12h              ; Mira si es monocromo o color
        mov bl,10h
        int 10h
        cmp bh,0
        mov ax,0002h            ; Modo 2 80x25 moocromo
        jnz monocrome
        mov al,3                ; Modo 3 80x25 color
monocrome:
        int 10h

        print init_msg
        cmp flag_install,0
        jz not_install_msg
        print installed_msg
not_install_msg:

        ret

set_text_mode endp

;===============================================================================

main proc

        mov ax,1a00h                    ; Testea la presencia de una VGA
        int 10h                         ; llamando a un servicio de la BIOS
        cmp al,1ah                      ; exclusivo de esa tarjeta
        jz vga_ok

        print init_msg                  ; Imprime mensaje inicial
        print not_vga_msg               ; Si no la detecta, imprime mensaje
        ret                             ; de error y termina

vga_ok:
        mov ax,3510h                    ; Obtiene direccin del vector 10h
        int 21h
        mov word ptr oldint10h,bx
        mov word ptr oldint10h+2,es

        mov si,offset init_msg          ; DS:SI= init_msg de este programa
        mov di,si                       ; ES:DI= init_msg del prog. resid.
        mov cx,init_len                 ; Comparamos todo el mensaje
        repz cmpsb
        jnz not_installed               ; Si se encontr residente
        mov flag_install,1              ; pone flag indicndolo
not_installed:

        mov ax,ds                       ; Restauramos ES
        mov es,ax

        mov cl,ds:[0080h]               ; CX=Long de la lnea de comandos
        xor ch,ch
        mov di,0081h                    ; Inicio de la lnea
        mov al,' '
        repz scasb                      ; Buscamos algo distinto de un espacio
        jz help                         ; Si no se encuentra, ayuda
        dec di                          ; Apuntamos al caracter encontrado

        cmp byte ptr es:[di],'-'        ; Detecta el switch de activacin o
        jz continue                     ; desactivacin
        mov flag_80x30,1
        cmp byte ptr es:[di],'+'
        jz continue
help:
        print init_msg                  ; Imprime mensaje inicial
        print help_msg                  ; Si no los encuentra, imprime
        ret                             ; mensaje y termina

continue:
        cmp flag_install,0
        jz install
        mov es,word ptr oldint10h+2     ; Si ya est instalado, copia el flag
        mov al,flag_80x30               ; de modo en el flag de modo del
        mov es:flag_80x30,al            ; programa residente
        call set_text_mode              ; cambia el modo actual
        ret                             ; y termina

install:
        mov ax,2510h                    ; Engancha vector
        mov dx,offset int10h
        int 21h
        call set_text_mode              ; Cambia el modo actual
        mov ah,49h                      ; Libera memoria del entorno
        mov es,ds:[002ch]
        int 21h
        mov dx,offset last_byte         ; Termina y se queda residente
        int 27h

main endp

end inicio
